#ifndef __GPUDB_H__
#define __GPUDB_H__

#include <shrUtils.h>
#include <cutil_inline.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <gpuDB_kernels.cuh>

#define HASH_ENTRIES     1024

unsigned int seed = time(NULL);
unsigned int rangeG = 512;
unsigned int rangeV = 100;
unsigned int size = 1000000;
bool verbose = true;
bool test = false;
char *inputFile;
char *outputFile;
uint2 *data;
unsigned int *serialCount, *serialSum, *serialSumSquared;

void computeParallelHashTable(unsigned int size, uint2 *data, Table &table, unsigned int rangeG);
void computeSerial(unsigned int size, uint2 *data, unsigned int *count, unsigned int *sum, unsigned int *sumSquared);
void copy_table_to_host(const Table &table, Table &hostTable, int elements);
void free_GPUTable(Table &table);
void free_table(Table &table);
void initialize_GPUTable(Table &table, unsigned int entries, unsigned int elements);
bool parseCommandLineArguments(const int argc, const char** argv);
void populate(uint2 *data);
void printUsage();
void testGPU(unsigned int size, uint2 *data);
void verify_table(const Table &table, const char *type);

#endif