#ifndef __GPUDB_KERNELS_H__
#define __GPUDB_KERNELS_H__

struct Entry {
	/*
	data.x = key
	data.y = count
	data.z = sum	// removed for now
	data.w = sumSquared // removed for now
	*/
	uint4	data;
	int		next;
};

struct Table {
	unsigned int	count;
	int				*entries;
	Entry			*pool;
};

__global__ void computeAggregation(unsigned int size, uint2 *idata, Table table, int *globalHashLocks, int *globalFreeLock, int *globalFirstFree);
__device__ __host__ unsigned int hash(unsigned int key, unsigned int count);
__global__ void testKernel(unsigned int size, uint2 *idata, uint2 *odata);

#endif
